using System;
using System.Collections.Generic;
using Vector2I = Vector.Vector2I;

public interface IPiece {
    Vector2I Pos { get; set; }
    string Name { get; set; }
    bool IsSelected { get; set; }
    Dictionary<string, object> Data { get; set; }

    event EventHandler<Vector2I> OnPos;
    event EventHandler<Vector2I> OnMove;
    event EventHandler<bool> OnSelected;
    event EventHandler<string> OnName;

    bool CanMove(Vector2I to);
    bool Move(Vector2I pos);
}
